ExhibitPlus - Change History

03.04.2007
----------

Removed all XHTML tags (e.g. self closing tags like <br />) to ensure downgrade to HTML4.01 validates. Double-checked pages to see if they validate - successful.
Changed target URL to point to http://exhibitplus.fyvie.net
Corrected some bugs in the logic of the sizing and positioning of foldernew.gif (this bug only appeared recently)
Added rel="nofollow" to the external links to firefox and w3c validation buttons - help to prevent page rank from bleeding unnecessarily.

*** Packed for release as v1.5 RC2!

26.03.2007
----------

Changed a variable in the display of number of elements when an index page is split up (page selector). Previously folder objects weren't calculated in the total number. Now they are.
Switched to a fix for the old minithumbs overlaying portrait images problem provided by Jarno Suni. Details here: http://jalbum.net/forum/thread.jspa?threadID=11367
Changed minimum required version to 7.1.3
Introduced ability for style files to specify filters. An example is the new zframe-white.css style sheet which includes the xborder filter. Hopefully users will play with this idea and create special style sheets which make use of filters.
Fixed bug where "Bypass slide mode" wasn't working correctly.

*** Packed for release as v1.5 RC1!


25.03.2007
----------

Added new stylesheet white.css and button set aqua-32px-lightbackground. Thanks to Robert Fyvie
Added new stylesheet light-blue.css and button set crystal-22px-lightbackground. Thanks to PauLoX
Fixed small bug introduced a few days ago where filename of thumbs always displayed regardless of GUI switch
Allow empty folder descriptions now defaults to on. This is because it is easier and more intuitive to add them via JAlbum's explorer
Changed the hover colour in many of the styles - it was fading into the background too much.
In firefox the up button on root was entering inside the index frame. Fixed
Previously filename would not be displayed if top level nav bar was not selected in landscape. Now fixed
Changed the logic slightly for the display of title and description on root page. If title altered manually then title will display, if not, it won't. Description will display if found for root, regardless of title.
Changed some formatting around the title and description at the top of index pages.
Added routines to scale and move the position of the foldernew.gif image to optimal sizes and positions depending on scaling of folder thumbnails and/or use of icons.


23.03.2007
----------

Fixed minor bug where scaling of folder thumbnails wasn't working correctly. Scale values below 100 were causing them to disappear completely. Standard folder icon can now scale down (but not up)
Rewrote certain elements to comply with new JA behaviour (since 6.0), previously JA was exempting E+ from this behaviour. This concerned folder thumbs, descriptions and titles.
Changed over from col and row iterators to the new file iterators. This allowed a clean way to display folders before thumbs in "mixed mode" index pages. Also simplified some code and removed a lot of unneeded tests for whether object was a file or a folder.
Removed thumbnail for folder icon switch in the E+ GUI because it now exists in the JA GUI. Skin behaviour does respect the JA switch however.


21.03.2007
----------

Updated cameras.properties to same version used in BluPlusPlus
Added Catalan translation thanks to Joan Vidal
Supressed display of backlink to documentation website, normally invisible under each slide
Fixed small bug with reading variables.inc inside the col and row iterators. Now moved to outside.
Fixed a small bug where oversized mini-thumbs were used on the slide page - this caused some nasty overlap and obscuring of thumbnails in Firefox.
Fixed a bug where alternate titles for images were not always displayed on slide and index pages.
Changed default setting for link to shutterfly to off. People can turn it on if they really want it.


15.03.2006
----------

Changed z-index to 20 for photoDataPopupBase class. This means EXIF data will not appear underneath mini-thumbs for some portrait slides.
Added some style positioning data that seemed to be missing for upButtonAtRootIndexPageForce in index.htt
Fixed long standing bug - imagemap not working correctly for portrait images in firefox. Thanks to schnitzel for pointing me in the right direction.
Removed ESC key from keyboard shortcuts, and the Page Up key from the pop-up help
Removed the "theSlide" anchor - it was causing trouble with Firefox.
Added mid-gray style thanks to Les Simmonds
Changed minithumb borders from dotted to dashed. Supposed to give more consistant look between IE and Firefox.

17.01.2006
----------

Removed a stray comment which was appearing in the html of originalslide2.htt

29.10.2005
----------

Prepared 1.4a for inclusion with JAlbum 6.0 RC1. 
Changed URL link to point to www.fyvie.net/photos/info_exhibitplus.html instead of exhibitplus.fyvie.net. The latter of these two was simply a redirect anyway.
Added Finnish translation
Added a titles.properties file to the samples directory

02.06.2005
----------

Suffered a hard disc failure, and lost some details in this file, and in some modification I'd made. Re-applied 4 bug fixes via the patch files, namely 14/001, 14/002, 14/003, 14/004. See patch files in the patches directory for further information.
Included updated Czech translation file.

01.04.2005
----------

*** V1.4 Released and bundled with JAlbum 5.2 ***

Added some exception handling to numericPart(), this avoids crashes when unexpected non-numeric EXIF data is returned from some images.
Changed the way variables are initialised in slide.bsh and index.bsh - should be a bit cleaner now
Updated variables.inc to include all new variables (except contents of Image Information tab)
Removed all references to iconPath and used the more reliable isDirectory method instead. Video file handling on index pages improved (note: due to issues with JAlbum the handling of video files is still less than perfect).
All language files syncronised for changes in 1.4 except Spanish and Icelandic
Small change in writePath(), meta.properties files are now read in all folders in the tree, rather than current folder.
Added Open Office to the list of charities supported and rearranged the code a little. Must get promotion.properties working another time
Fixed small bug where the fallback to the manual calculation of 35mm equivalence was not running.

31.03.2005
----------
Fixed a small glitch in the sample footer.inc - content now formatted correctly and centered.

25.03.2005
----------
Altered writePath() slightly - if meta.properties was used for multi level index links on slide, the meta.properties from the parent was read instead - corrected.

22.03.2005
----------
Added full meta data routines from Olivier
Compiled getFolderIcons() and thumbScaleInit()
Resolved issue with folder thumbs not being correctly displayed
Changed the way AVI files are handled - they now do not process as a directory on index pages.
Added unique filename generation for guestbook
Tested guestbook - seems to function as desired
Changed position of multilevel navigation bar on index page
Removed IE6 display bug ("strange hanging text") - thought this was done earlier but it wasn't.
Released dev.7 version - bundled with JA 5.2 rc2

16.03.2005
----------
imageCalc() now compiled. 
Released dev.6 version. 

15.03.2005
----------
Slide pages now show meta data correctly. Compiled mini thumb routine (now working correctly) and nav button HTML routine. Small speed increase.

14.03.2005
----------
Incorporated latest changes from Olivier - individual EXIF and IPTC fields now selectable in UI, 35mm calculation overhauled and the new cameras.properties system is in use. However, slide pages don't show meta data - must check. 

13.03.2005
----------
Moved routine to generate nav buttons on the slide page into slide.bsh - it now loads the HTML into a variable for later use (and repeat)
Moved the sep variable (slide.htt) into slide.bsh
Main slide images now carry alt and title tags correctly
Other minor optimisations
Changed position of w3c logos slightly so any wide footers wouldn't be overwritten
Cleaned up some spacing around the multilevel nav functions on the index page.
Added additional checks to make the UI checks for the guestbook cleaner.
Started compiling of scriplets using latest bleeding edge beta from David, currently many variables do not work correctly.

12.03.2005
----------
cameras.properties file added - fallback routine to calculate 35mm equivalency of certain cameras based on fixed focal length multiplier added. Credit: Olivier Biot
 

10.03.2005
----------
Released dev.4 version for testing.
Fixed memory leak problem using <%! %> syntax.
Moved all significant chunks of beanshell in index.htt and slide.htt to methods in index.bsh and slide.bsh - using the include once syntax. 15% improvement in speed.

03.03.2005
----------
Released dev version 3 to David for inclusion in upcoming release candidate of 5.2. A few bugs remain, namely guestbook to be properly sorted out, .avi files not working properly, and memory leak problems remain. This version has not been properly tested.

20.02.2005 - 03.03.2005
-----------------------
Changelog not properly implemented during this period.
Added logic to onload.bsh to handle guestbook functions
Tried various versions of the guestbook (Hint, if you use this grant write permissions to the /guestbook directory on your server when you put your album there)
ALso did extensive testing of various JA 5.2 beta versions, and use of the new ${} variable types. 100% increase in speed without compiling scriptlets!!

19.02.2005
----------
Optimised most routines in index.htt, originalside.htt, originalslide2.htt

18.02.2005
----------
Fixed layout issue with "new" icon over folder - now displays in the same position in both IE and Mozilla/Firefox. 
When using larger thumbnails than the folder.gif icon, text displayed to the right of the folder.gif will move out further so as to be in the same position as the text next to the larger thumbnails (if scaling of larger thumbnails is employed).
Converted variables where possible from <%= %> to ${ } format (slide.htt only).
Optimised some routines in slide.htt.

12.02.2005
----------
Added an "About" tab to the UI - mostly stolen from BPP :-)

11.02.2005
----------
$totalImages and $totalAlbumImages are now working correctly in JAlbum 5.2, index.htt was changed to use these instead. This resolved a previous issue where counts of images/folders on index pages was done incorrectly.
Bug introduced in JA5.1 - variables being knocked out by processtemplate, work-around put in place.

09.02.2005
----------
Added Czech language file thanks to Vláda

08.02.2005
----------
If there is a filename for an image with .txt extension (e.g. IMG_0001.txt) this can now hold an additional title= field. Alteratively there can be a titles.properties file containing a list of filenames and their replacement titles. This allows someone to display an alternate title instead of the image name on all index, slide and full screen views of images. However, the original filename will still display when hovering over images in the row of minithumbs on the slide page.
Made some small cosmetic changes to the appearance of folder entries on the index page.
Added Japanese language file thanks to Shin-ichisan.

05.02.2005
----------
footer.inc and header.inc can now be included in each image directory. This is helpful if you want to have a different header and footer in each folder. If you elect to use this feature, and forget to include a header.inc or footer.inc, it will take one from the root directory if present. If you don't like this and want to have a blank footer or header in a given folder, include a blank file.

04.02.2005
----------
The old singleFolderMode switch was retired. Now E+ handles this issue a little better, namely:
	* it will not display the multi-level index links (for quick navigation) if it is displaying the root folder. 
	* If a meta.properties description is not displayed on the root folder, it will not be displayed, and neither will an error message (error messages will be displayed for sub-folders though!).
	* Unless a title is explicity defined in the meta.properties for the root folder, no title will be displayed above the description (if present). 
	* Unless a title is explicity defined in the meta.properties then a default language string will be used for the root entry in the multi-level index links when browsing sub-folders. Previously the name of the root folder (e.g. photos) would be used, and it didn't really look right. The default string for this in English is "Top index page" - see texts.properties file for your language if you'd like to change it.
Multi-level navigation links now available on slide pages as well
Multi-level navigation links can now be switched on or off via the UI for either slide or index pages independantly.
IE and Firefox have different default padding, borders etc. Added some hard coded properties to body to ensure that layout is exactly the same in both browsers.
IE6 running on XP SP2 now disables scripting by default, this causes certain functions not to work. A warning icon now appears at the bottom left of the screen if scripts are disabled, and moving the mouse over it provides the user with an explanation that certain functions will not work.

12.01.2004
----------
E+ now requires JA 5.2 to run
Issue with force image dimensions and use thumbnail for folder icon together have been resolved

01.01.2004
----------
Padding around thumbnails in index can now be changed via the UI
Implemented a much better work-around that actually works for the hanging text problem
Date issues now fixed, still need to test formats involving the month name
Fixed format mode now has a completely tableless layout - i.e. no more crappy <table><tr><td> elements!


05.12.2004
----------
Added Portuegese language file thanks to Olivier Biot
Changed landscape only mode so it is now possible to force either portrait or landscape modes for slide orientation
Added option to remove filename and image counter from slide page
Added option to show promotional buttons on each page to support certain charities.

04.12.2004
----------
Added a series of &nbsp characters in the IE6 bug workaround for "hanging text". Was unable to duplicate or test it though. Details at http://www.jalbum.net/forum/thread.jspa?messageID=26268&#26268
Added Spanish language file thanks to Alfredo Pérez Real
Added ability to scale folder thumbnails via the UI


01.09.2004
----------
Updated the dutch language file with some corrections.
Added italian language file.

06.06.2004
----------
Forgot to put language strings into the image map. Corrected

*** Version 1.3a released 06.05.2004 ***

06.05.2004
----------
Released 1.3a. Some minor changes:
Altered pre-load code to use imagePath instead of fileName, only important when original images are included without linking (rare)
Altered keyboard shortcuts slightly so that "#" is put into the URL instead of "" when at first or large page. IE was displaying the contents of the directory in this case.
Changed date on the display of onload.bsh
Added routine to clear out the res directory if an older version of ExhibitPlus is detected.

*** Version 1.3a released 01.05.2004 ***

30.04.2004
----------
Updated metodi-black.css to correct small issue

29.04.2004
----------
Wrote a formal test procedure into the documentation
All language updates received - thank you translators
Added some additional code for an alternate res directory via undocumented variable resSubDir. This was purely for my own use, and has no practical user application (unless the user wants to run multiple styles like I do in my sample gallery)
Added some vertical-align properties to elements in the page selection code. Now lines up the same way in both IE and Gecko

27.04.2004
----------
Fixed an obscure bug: When fullscreen buttons were not used in fullscreen buttons and the user activated the slide show, the slideshow would break and keyboard shortcuts would also break.
Cleaned up a lot of CSS. Ordered CSS elements logically, and transfered all CSS elements to the colour style sheet. Should be a bit easier and pleasant for people wanting to make changes
Removed IE glow effect, removed IE opacity effect. 
Retired "full CSS conform" switch, now everything is full CSS conform all the time.
Brought back the image map over slide image from a pre XHTML1.1 version of the skin. Saving images now possible, validates under XHTML1.0 (but not 1.1)
"Panaoramic" shots used as folder thumbnails are now clipped so that they don't overflow onto the text (rare condition)
Added additional CSS classes for some div elements

25.04.2004
----------
Added CSS elements for all styles for date, name and comments under thumbnails. Changed structure of hyperlink for name under thumbnail. No underline now, looks better

24.04.2004
----------
Added ui.displayFolderDateAdded.setToolTipText, ui.imageDateUnderThumbnail.setToolTipText, ui.displayFolderDateAdded, ui.imageDateUnderThumbnail to language
Added controls to put date under thumbnails, and to supress folder added date on index.
Added folderIconDirectory= variable to meta.properties, it is now possible to specify a different sub folder to look for a thumbnail to use as a folder icon.
Fixed minor bug which prevented the copying of button sets. 
Added routine to index.htt which copies over the additional help.gif, info.gif, download.gif, orderprints.gif files if they are present in the button set
Added some more language strings
Updated all documentation ready for the release of 1.3

22.04.2004
----------
Changed style elements slightly around the EXIF data. Now easier for people to control this section with CSS a little better.

21.04.2004
----------
Added 3 new button sets from metodi
Updated various language files

19.04.2004
----------
Borrowed and modified routine from BluPlusPlus to automatically read directory and present languages in the UI's drop down box
Also a routine to give the ability to override the default icon set for a given style via the UI.

18.04.2004
----------
Added new variable numberIndexColumns, and a corresponding change in the UI. User can now set number of columns to display the sub-folders on an index page. Previously this was 1. Depending on the description, anything above 3 will not look good, especially on a screen with low resolution!
Added an overflow-y: auto to the html section of the basestyle.css. This seems to fix a greyed-out vertical scrollbar that IE seemed to display on index pages. Mozilla had no issues with this before or after the change.
Took out the overflow-y: property shortly afterwards. Had an unfortunate side-effect of a horizontal scrollbar in IE

17.04.2004
----------
When using "force" option for up button at index page, previously it referenced a parent index page which didn't exist. Now a test is done to see if the page exists, and if not, it references ../ instead.


16.04.2004
----------
Added Serbian language file
Added Icelandic language file
Changes some single quotes to double quotes for the moveOn() routine in slide.htt and originalslide.htt


15.04.2004
----------
Converted all filenames to lowercase to avoid possible problems with unix systems
Added preview images for all styles (made possible in JAlbum 4.3)
Added event handling to onload.bsh. Can be used for future features
Changed from XHTML 1.1 to XHTML1.0 Strict DOCTYPE and adjusted all logos accordingly
Specified both title and alt for all image file references

13.04.2004
----------
Added dutch language file
Corrected small bug with language files not being read for noDescript and folderJump
Made adjustments so that characters possible with UTF-8 encoding (e.g. Cyrillic) can now be used in meta.properties, and comments.properties etc. Resaved all sample file packaged with ExhibitPlus into UTF-8 encoding.
Rewrote code concerning display of EXIF data. Now generated from an array, reducing size of slide.htt and making the adding of additional fields very simple. Added a few new fields, including complete IPTC data (if available)

24.02.2004
----------
Added German language file. Not much progress since the beginning of Feb due to travel commitments. Decided to publically release test version. Will return home on March 19 and can add finishing touches at that point. Development work 99% complete. This version should have very few issues.

21.01.2004
----------
Mini thumbnails now appear with the image label when the mouse hovers over them

There is a new variable which allows the user to change the scaling factor for mini thumbs

Changes to the UI with some small layout issues

Conversion of both the UI and all relevant .htt files to a multilingual interface. Now additional language files can be plugged in easily.


20.01.2004
----------
Rewrote sections of Keyboard help pop-up, now does not use the bottom property (incompatible with IE5/Mac)

Rewrote sections of the EXIF pop-up, now uses 2 absolutely positioned divs, no longer blocking navigation items in Mozilla and Opera

Bumped up z-index on mini-thumbs and nav element in portrait mode - was previously disappearing behind image on Mozilla and other browsers

Corrected small issue where imagePaddingBottom contained a decimal point, now is integer


16.01.2004
----------
Fixed small bug: Image name under thumbnail in free-flowing mode caused all images to stack vertically

Re-wrote absolute positioning for the 4 small icons in the picture frame. Now they position from the top rather than the bottom, due to work around for IE5/MAC

Adjusted XHTML slightly for keyboard help and EXIF info to function correctly under Safari and IE5/MAC. Now seems to work on all browsers and platforms (so far!)

Corrected small bug - missing ID on the shutterfly form - now functions correctly for XHTML


15.01.2004
----------
Added fixed width to containing DIV of buttons within image frame (e.g. help, EXIF, shutterfly, download original) - this was the fix issue in Opera 7

Removed containing DIVs from around mini-thumbs, now behaves correctly in Opera 7

Fixed a small issue with the formatting of the image name and bottom navigation buttons not looking so nice with the top navigation buttons were disabled on the the slide page.

Corrected shuttefly routine. It disappeared a few days ago by mistake - added back in.


13.01.2004
----------
Corrected small bug preventing the display of w3C CSS logo on slide.htt when fullCSSConform was set to true.

Removed table-within-table in the fixed format layout. 

Added additional logic to correctly add </tr> in the correct place so as to pass XHTML 1.1 validation and preserve identical layout between IE and Mozilla (also tested and validated for both sub folders present and not present in a given directory)

Added comments to all example include files and .htt files warning users not to use depreciated tags and to ensure that all modifications are XHTML 1.1 compliant


12.01.2004
----------
Converted index.htt to XHTML 1.1

Converted slide.htt to XHTML 1.1

Converted originalslide.htt to XHTML 1.1

Converted originalslide2.htt to XHTML 1.1

Replaced old client side image map in slide.htt with full CSS solution - the client map started to fail under XHTML 1.1 and needed to be replaced by something more modern.

It is now possible to set a variable delay value for slideshow via the UI

It is also now possible to set "continuous mode" for the slideshow via the UI - slideshow will not stop when it gets to the end, but will loop back again to the beginning

Fixed problem when using fixed table mode in mozilla. Everything now correctly centered on index page when using fixed format mode


11.01.2004
----------
Finally made the folder icons / thumbnails and the "new" graphic as hyperlinks on the index page.

Added new variable commentAboveSlide - credit to Markus Rietzler for the idea

Fixed a small bug introduced on the 06.01.04 - Image name was in the wrong position for portrait images.


07.01.2004
----------
Index.htt was the only file which took the character encoding setting from JAlbum. Other files were hardcoded. Corrected

Corrected problem with portrait images in 35mm focal length function - thanks to Markus von Arx

Reformatted the underlying images which form the base for the glow effect in IE. They are now completely hidden, were previously slightly visible in Mozilla when using the lighter styles (black horizontal line visible under frame)

Rewrote sections of index.htt - display is now consistent between IE and Mozilla. Exception is that the "new" icon appears to the left of the thumbnail on Mozilla and to the right on Explorer. Seemingly unavoidable, but not the end of the world.

Thumbnails as folder icons on the index page now display in their correct aspect ratio, and will automatically center (for example if some part portrait and some are landscape)


06.01.2004
----------
David updated onload.bsh to take advantage of new features in JAlbum, synced the 4.1.4 release onload.bsh with development version

Added singleFolderMode - designed for people who don't have a hierarchy in their album structure - disables navigation and folder description elements for the current folder on the index page

Title in browser window now reflects alternative title if title= is used in a meta.properties file

Fixed tiny bug causing the purple background to bleed to the left in dark.css when using a footer.inc file

Rewrote substancial sections of slide.htt, specifically to do with the framing around images, and the positioning of the  small icons. After this redesign functions now work properly in mozilla, and more importantly behaviour is 99% consistant between IE and Mozilla. All small icons now appear in Mozilla, and in the same order they do in IE.

Rewrote keyboard shortcut help - now works in both Mozilla and IE

Modified the display of EXIF data in userselect mode. Old bug in IE with horizontal scroll bar appearing until the mouse was moved is now eliminated


Can't remember which date
-------------------------
Fixed small bug causing horizontal scrollbar to appear on index page
